diff --git a/run/john.conf b/run/john.conf
index 4d5699395d..4c8358e637 100644
--- a/run/john.conf
+++ b/run/john.conf
@@ -229,10 +229,10 @@ ShowUIDinCracks = N
 
 # This allows you to read extra pot files when loading hashes. Nothing will
 # ever be written to these files, they are just read. Any directory in this
-# list will be traversed and ALL files in it will be read. However there will
-# NOT be any recursion down further directory levels. Any entries that does
-# not exist will be silently ignored.
-#[List.Extra:Potfiles]
+# list will be traversed and files in it with an extension of .pot will be
+# read. However there will NOT be any recursion down further directory levels.
+# Any entries that does not exist will be silently ignored.
+[List.Extra:Potfiles]
 #somefile.pot
 #somedirectory
 #$JOHN/my.pot
diff --git a/src/john.c b/src/john.c
index 960c1f461b..36dea74ad8 100644
--- a/src/john.c
+++ b/src/john.c
@@ -956,6 +956,68 @@ static void john_load_conf_db(void)
 	}
 }
 
+static void load_extra_pots(void)
+{
+	struct cfg_list *list;
+	struct cfg_line *line;
+
+	if ((list = cfg_get_list("List.Extra:", "Potfiles")))
+	if ((line = list->head))
+	do {
+		struct stat s;
+		char *name = path_expand(line->data);
+
+		if (!stat(name, &s) && s.st_mode & (S_IFREG | S_IFLNK))
+			ldr_load_pot_file(&database, name);
+#if HAVE_DIRENT_H && HAVE_SYS_TYPES_H
+		else if (s.st_mode & S_IFDIR) {
+			DIR *dp;
+
+			dp = opendir(name);
+			if (dp != NULL) {
+				struct dirent *ep;
+
+				while ((ep = readdir(dp))) {
+					char dname[PATH_BUFFER_SIZE];
+					char *p;
+
+					if (!(p = strrchr(ep->d_name, '.')) ||
+					    strcmp(p, ".pot"))
+						continue;
+
+					snprintf(dname, sizeof(dname), "%s/%s",
+					         name, ep->d_name);
+
+					if (!stat(dname, &s) &&
+					    s.st_mode & (S_IFREG | S_IFLNK))
+						ldr_load_pot_file(&database,
+						                  dname);
+				}
+				(void)closedir(dp);
+			}
+		}
+#elif _MSC_VER || __MINGW32__
+		else if (s.st_mode & S_IFDIR) {
+			WIN32_FIND_DATA f;
+			HANDLE h;
+			char dname[PATH_BUFFER_SIZE];
+
+			snprintf(dname, sizeof(dname), "%s/*.pot", name);
+			h = FindFirstFile(dname, &f);
+
+			if (h != INVALID_HANDLE_VALUE)
+			do {
+				snprintf(dname, sizeof(dname), "%s/%s",
+				         name, f.cFileName);
+				ldr_load_pot_file(&database, dname);
+			} while (FindNextFile(h, &f));
+
+			FindClose(h);
+		}
+#endif
+	} while ((line = line->next));
+}
+
 static void db_main_free(struct db_main *db)
 {
 	if (db->format &&
@@ -1113,65 +1175,7 @@ static void john_load(void)
  * Load optional extra (read-only) pot files. If an entry is a directory,
  * we read all files in it. We currently do NOT recurse.
  */
-		{
-			struct cfg_list *list;
-			struct cfg_line *line;
-
-			if ((list = cfg_get_list("List.Extra:", "Potfiles"))) {
-				if ((line = list->head)) {
-					do {
-						struct stat s;
-						char *name = path_expand(line->data);
-
-						if (!stat(name, &s)) {
-							if (s.st_mode & S_IFREG) {
-								ldr_load_pot_file(&database, name);
-							}
-#if HAVE_DIRENT_H && HAVE_SYS_TYPES_H
-							else if (s.st_mode & S_IFDIR) {
-								DIR *dp;
-
-								dp = opendir(name);
-								if (dp != NULL) {
-									struct dirent *ep;
-
-									while ((ep = readdir(dp))) {
-										char dname[PATH_BUFFER_SIZE];
-
-										snprintf(dname, sizeof(dname), "%s/%s",
-										         name, ep->d_name);
-
-										if (!stat(dname, &s)) {
-											if (s.st_mode & S_IFREG) {
-												ldr_load_pot_file(&database,
-												                  dname);
-											}
-										}
-									}
-									(void)closedir(dp);
-								}
-							}
-#elif _MSC_VER || __MINGW32__
-							else if (s.st_mode & S_IFDIR) {
-								WIN32_FIND_DATA f;
-								HANDLE h;
-								char dname[PATH_BUFFER_SIZE];
-								snprintf(dname, sizeof(dname), "%s/*.pot", name);
-								h = FindFirstFile(dname, &f);
-								if (h != INVALID_HANDLE_VALUE) {
-									do {
-										snprintf(dname, sizeof(dname), "%s/%s", name, f.cFileName);
-										ldr_load_pot_file(&database, dname);
-									} while (FindNextFile(h, &f));
-									FindClose(h);
-								}
-							}
-#endif
-						}
-					} while ((line = line->next));
-				}
-			}
-		}
+		load_extra_pots();
 
 		ldr_fix_database(&database);
 
